

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import javax.swing.JPanel;

import java.awt.Color;

import javax.swing.JFrame;
import javax.swing.JPanel;



public class EnergyPlotPanel extends JPanel{

    MyWorld world;
    int PAD = 20;
    boolean drawLine = true;
    boolean drawDots = true;
    int dotRadius = 3;
	SerialTest serial;
    int Datos = 20;
    int t=0;
	JPanel panel = new JPanel();
	 
  
    double [][] data = new double[3][Datos];   
    
    int correccion=0;
	Color color = new Color(255,0,0);

	 public EnergyPlotPanel(MyWorld w, SerialTest st){
	 JFrame frame = new JFrame("Grafico");
	 serial = st;
	 world = w;
	 frame.add(panel);
	 frame.setSize(260, 60);
	 frame.setVisible(true);
	 }

    
    public void resetData(){
    for(int l=0; l<3; l++)
        for(int k=0; k<Datos; k++)data[l][k]=0.0;
    }
    
    @Override
    protected void paintComponent (Graphics g)
    {
        super.paintComponent(g);
        Graphics2D g2 = (Graphics2D)g;
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        int w = getWidth();
        int h = getHeight();
        Color[] colorList = {Color.green, Color.blue, Color.magenta};
        //g2.drawString("Energía Cinetica :", 165, 15);
        //g2.drawString("Energía Potencial:", 165, 35);
        //g2.drawString("Energía Mecánica :", 165, 55);
        
        g2.setPaint(colorList[0]);
        g2.fillOval(280-dotRadius, 10-dotRadius, 3*dotRadius, 3*dotRadius);
        //g2.setPaint(colorList[1]);
        //g2.fillOval(280-dotRadius, 30-dotRadius, 3*dotRadius, 3*dotRadius);
        //g2.setPaint(colorList[2]);
        //g2.fillOval(280-dotRadius, 50-dotRadius, 3*dotRadius, 3*dotRadius);
        
        g2.setPaint(Color.green);
        //g2.drawLine(PAD, PAD, PAD, h-PAD);
        //g2.drawLine(PAD, h-PAD, w-PAD, h-PAD);
        double xScale = (w - 2*PAD) / (data[0].length + 1);
        double maxValue = 50.0;
        double yScale = (h - 2*PAD) / maxValue;
        
        // Locacion original
        int x0 = PAD;
        int y0 = h-PAD;
        
        // Se dibuja una linea que une los puntos
        if (drawLine)
        {
            for (int count=0; count<3; count++)
            for (int j = 0; j < t; j++)
            {
                int x1 = x0 + (int)(xScale * (j+1));
                int y1 = y0 - (int)(yScale * data[count][j]);
                int x2 = x0 + (int)(xScale * (j+2));
                int y2 = y0 - (int)(yScale * data[count][j+1]);
                g2.drawLine(x1, y1, x2, y2);
            }
        }

        // Los puntos son pequeños círculos de color
        if (drawDots)
        {
            for(int count=0; count <3; count++){
            g2.setPaint(colorList[count]);
            for (int j = 0; j < t; j++)
            {
                int x = x0 + (int)(xScale * (j+1));
                int y = y0 - (int)(yScale * data[count][j]);
                g2.fillOval(x-dotRadius, y-dotRadius, 2*dotRadius, 2*dotRadius);
            }
            }
            
        }
        
        if(t/2 != world.getT()-correccion){
            t++;
            t%=Datos;
            if(t==0)correccion+=Datos;
            data[0][t]=world.getKEnergy();
            //data[1][t]=world.getPEnergy();
            //data[2][t]=world.getMEnergy();
            
        }
        
        panel.add(this);
        
        
    }


}

